<template>
  <disciplina
    :to="to"
    :loadingTitle="loadingTitle"
    :loadingContent="loadingContent"
    :data="data"
  />
</template>
<script>
import store from "@/store";
import Disciplina from "@/views/secure/sistema-informacion/dashboards/v2/disciplinas/components/graficas/Disciplina.vue";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-DisciplinaImpl",
  components: {
    Disciplina,
  },
  props: {
    loadingTitle: {
      required: false,
      default: true,
      type: Boolean,
    },
    to: {
      required: false,
      default: null,
      type: Object,
    },
    data: {
      required: true,
      type: Object,
    },
    semaforoUtils: {
      required: true,
    },
  },
  data() {
    return {
      loadingContent: true,
      semaforo: null,
    };
  },
  watch: {
    semaforoUtils(val) {
      this.setBarColor();
    },
  },
  methods: {
    getNegociosDisciplina() {
      axios(
        "/sistema-informacion/tablero/reportes/v1/disciplinas/" +
          this.data.idDisciplina +
          "/negocios/busquedas"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.data.negocios = data.resultado.negociosDisciplina;
            this.data.negocios = this.data.negocios.map((negocio) => {
              negocio.imagen = serviceCommons.getLogoImageByIdNegocio(
                negocio.idNegocio
              );
              negocio.color = "grey";
              this.setBarColor();
              return negocio;
            });
            this.loadingContent = false;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.semaforo = {};
          } else {
            console.log(error);
          }
        });
    },
    setBarColor() {
      if (this.semaforoUtils && this.data && this.data.negocios) {
        this.data.negocios = this.data.negocios.map((negocio) => {
          negocio.color = this.semaforoUtils.getColor(negocio.calificacion);
          return negocio;
        });
      }
    },
  },
  created() {
    this.getNegociosDisciplina();
  },
};
</script>
